/***************************************************************************
                          analoginput.cpp  -  description
                             -------------------
    begin                : Mon Jul 17 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : joris@struyve.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id: analoginput.cpp,v 1.9 2002/08/18 18:24:26 js Exp $
 *
 */

#include "k8ktest.h"

AnalogInput::AnalogInput(int min,int max, int linestep,int pagestep,int value,int io,QString label,QWidget *parent,char *name)
	:QFrame(parent,name)
{
	this->setFrameStyle(QFrame::Box|QFrame::Raised);
	val = new QScrollBar(min,max,linestep,pagestep,value, QScrollBar::Vertical, this, "scroll");
	valuelabel = new QLabel(this,"val");
	valuelabel->setAlignment(Qt::AlignHCenter);
	valuelabel->setText(tr("%1").arg(value));
	
	cardlabel = new QLabel(this,"card");
	cardlabel->setAlignment(Qt::AlignHCenter);
	cardlabel->setText(label);
	
	/* set the io_channel */
	this->io_channel = io;
	
	/* read initial value to the K8000 card
	ReadADchannel(io_channel);
	val->setValue((AD_matrix[activechainnumber][io_channel]-val->maxValue())*-1);*/
	
	connect( val, SIGNAL(valueChanged(int) ), SLOT(ChangeValue(int)) );
}

AnalogInput::~AnalogInput()
{}

void AnalogInput::ChangeValue(int value)
{
	/* update the label with the new value */
	valuelabel->setText(tr("%1").arg(value));
	/* emit the change signal */
	emit this->ValueChanged(value);
}

void AnalogInput::Refresh()
{
	/* read the current value to the K8000 card */
	ReadADchannel(io_channel);
	//qDebug("AD %d = %d",io_channel,AD_matrix[activechainnumber][io_channel]);
	/* set the scrollbar */
	val->setValue((AD_matrix[activechainnumber][io_channel]-val->maxValue())*-1);
	
	/* set the label and emit a signal */
	this->ChangeValue(AD_matrix[activechainnumber][io_channel]);
}

int AnalogInput::GetValue()
{ return (val->value()-val->maxValue())*-1; }

void AnalogInput::SetGeometry(int x,int y,int w,int h,int s)
{
	int borderspace = 3;
	int interspace = 5;
	int texth = 13;
	
	this->setGeometry(x,y,w,h);

	valuelabel->setGeometry(borderspace,h-borderspace-texth,w-2*borderspace,texth);
	cardlabel->setGeometry(borderspace,borderspace,w-2*borderspace,texth);
	val->setGeometry((w/2)-(s/2),texth+interspace+borderspace,s,
					h-(2*texth)-(2*borderspace)-(2*interspace));
	
}
